/*
 * @(#)Blank.java
 *
 * This file is part of webCDwriter - Network CD/DVD Writing.
 *
 * Copyright (C) 2001-2006 Jrg P. M. Haeger
 *
 * webCDwriter is free software. See CDcreator.java for details.
 *
 * Jrg Haeger, 11.06.2001
 */

import javax.swing.JDialog;
import javax.swing.JOptionPane;


/**
 * Execution of a "blank" command.
 *
 * @version 20060424
 * @author Jrg P. M. Haeger
 */
public class Blank extends Burn {
	private boolean all;

	public Blank(boolean all) {
		this.all = all;
	}

	protected JDialog createSuccessDialog() {
		optionPane = new JOptionPane(
			i18n(".success"),
			JOptionPane.INFORMATION_MESSAGE,
			JOptionPane.DEFAULT_OPTION,
			null, options);
		return optionPane.createDialog(
			CDcreator.mainWin, i18n("titleBurnResult"));
	}

	protected void execBurnCommand() {
		if (Options.acceptKey.length() > 0)
			execCommand("setAcceptKey "
				+ spaceToEsc(Options.acceptKey));
		if (Mode.isMediumDVD())
			execCommand("setMedium " + Mode.medium);
		if (CDcreator.writeProtection && Options.rejectEmptyCD)
			execCommand("setRejectEmptyCD");
		if (CDcreator.writeProtection && Options.rejectWithoutUserID)
			execCommand("setRejectWithoutUserID");
		if (Options.speed > 0)
			execCommand("setSpeed " + Options.speed);
		String cmd = "blank ";
		if (all)
			cmd += "all";
		else
			cmd += "fast";
		execCommand(cmd);
	}
}
