/*
 * @(#)BurnCopy.java
 *
 * This file is part of webCDwriter - Network CD Writing.
 *
 * Copyright (C) 2001-2005 Jrg P. M. Haeger
 *
 * webCDwriter is free software. See CDcreator.java for details.
 */

/**
 * This class sets the options of a BurnCopy command
 * on the server.
 *
 * @version 20050614
 * @author Jrg P. M. Haeger
 */
public class BurnCopy extends Burn {
	protected void execBurnCommand() {
		execCommand("burnCopy");
	}

	protected void execOptions() {
		if (Options.simulate)
			execCommand("setLaserOff");
		if (Options.acceptKey.length() > 0)
			execCommand("setAcceptKey "
				+ spaceToEsc(Options.acceptKey));
		if (Options.blankTOC)
			execCommand("setBlankTOC");
		if (Options.closeCD)
			execCommand("setCloseCD");
		if (Options.copies > 1)
			execCommand("setCopies " + Options.copies);
		execCommand("setMedium " + spaceToEsc(Mode.medium));
		if (Options.overburn)
			execCommand("setOverburn");
		execSetProjectInfo();
		if (CDcreator.writeProtection && Options.rejectEmptyCD)
			execCommand("setRejectEmptyCD");
		if (CDcreator.writeProtection && Options.rejectWithoutUserID)
			execCommand("setRejectWithoutUserID");
		if (Options.doVerify() && !Mode.audioCD())
			execCommand("setVerify");
		if (Options.waitForEmptyCD)
			execCommand("setWaitForEmptyCD");
		if (Options.writer.length() > 0)
			execCommand("setWriter " + spaceToEsc(Options.writer));
	}
}
