#
# spec file for webCDwriter
#

%define name webCDwriter
%define version 2.8.2
%define release 1

%if %(test -e /etc/mandrake-release && echo 1 || echo 0)
	%define release 1mdk
%endif

%if %(test -e /etc/SuSE-release && echo 1 || echo 0)
	%define release 1SuSE
%endif

# the default user and group that run CDWserver
%define GROUP cdwserve
%define USER cdwserve

# the default directories (see the beginning of configure)
%define BINDIR /usr/bin
%define CONFIGDIR /etc/CDWserver
%define EXPORTDIR /var/CDWserver/export
%define HTTPDIR /var/CDWserver/http
%define LOGDIR /var/log/CDWserver
%define MNTDIR /var/CDWserver/mnt
%define PROJECTSDIR /var/CDWserver/projects
%define SBINDIR /usr/sbin
%define SPOOLDIR /var/spool/CDWserver
%define TOOLSDIR /var/CDWserver/bin

%define BASEDIR /var/CDWserver

%define INITDIR /etc/init.d
%if %(test -d %{INITDIR} && echo 0 || echo 1)
	%define INITDIR /etc/rc.d/init.d
%endif
%if %(test -d %{INITDIR} && echo 0 || echo 1)
	%define INITDIR /etc/init.d
%endif

%define _unpackaged_files_terminate_build 0

Summary: Network CD and DVD Writing
Name: %{name}
Version: %{version}
Release: %{release}
License: GPL
Group: System/Servers
Source: %{name}-%{version}.tar.bz2
URL: http://JoergHaeger.de/webCDwriter/
Requires: cdrecord >= 1.10, mkisofs, /usr/sbin/useradd
BuildRoot: %{_tmppath}/%{name}-buildroot

%description
webCDwriter can be used to make the CD- and DVD-writer(s)
connected to a Linux box available to all users in your network.
It consists of the server CDWserver and the clients webCDcreator
and rcdrecord.
CDWserver stores the files transmitted by the clients, reserves
the CD-writer and controls the CD-writer using cdrecord.
webCDcreator is a Java(TM) applet that runs within your browser
or by Java(TM) Web Start, assists you when putting together a CD
and transmits the files.
Finally rcdrecord is a command line client that tries to offer
the functionality of cdrecord over the network (not complete yet).

%prep
if [ ! -e $RPM_BUILD_ROOT/dev/ ]; then
	rm -rf $RPM_BUILD_ROOT
fi

%setup

%build
if [ -e /usr/include/security/pam_appl.h ]; then
	./configure --pam
else
	./configure
fi
make

%install
make install DESTDIR=$RPM_BUILD_ROOT

%clean
if [ ! -e $RPM_BUILD_ROOT/dev/ ]; then
	rm -rf $RPM_BUILD_ROOT
fi

%files
%defattr(-, root, root)
%doc COPYING CREDITS ChangeLog README *.html
%dir %{BASEDIR}/
%dir %{CONFIGDIR}/
%config(noreplace) %attr(-, %{USER}, %{GROUP}) %{CONFIGDIR}/accounts
%config(noreplace) %attr(-, %{USER}, %{GROUP}) %{CONFIGDIR}/config
%{CONFIGDIR}/config.default
%config(noreplace) %{CONFIGDIR}/config-root
%config(noreplace) %{CONFIGDIR}/greeting
%config(noreplace) %{CONFIGDIR}/insertCD*.html
%config(noreplace) %{CONFIGDIR}/mime.types
%config(noreplace) %attr(-, %{USER}, %{GROUP}) %{CONFIGDIR}/password
%{INITDIR}/CDWserver
/etc/pam.d/cdwserver
%{BINDIR}/cdrdao-dummy
%{BINDIR}/cdrecord-dummy
%attr(4710, root, %{GROUP}) %{BINDIR}/CDWrootGate
%attr(4710, root, %{GROUP}) %{BINDIR}/CDWverify
%{BINDIR}/CDWverify-dummy
%{BINDIR}/dvd+rw-format-dummy
%{BINDIR}/files2cd
%{BINDIR}/growisofs-dummy
%{BINDIR}/MD5Verify.jar
%{BINDIR}/rcdrecord
%{BINDIR}/tar2rpm.sh
%{SBINDIR}/CDWconfig.sh
%{SBINDIR}/CDWpasswd
%{SBINDIR}/CDWserver
%{SBINDIR}/CDWuseradd
%dir %{TOOLSDIR}/
%dir %{EXPORTDIR}/
%{EXPORTDIR}/*
%dir %{HTTPDIR}/
%config(noreplace) %{HTTPDIR}/about.html
%config(noreplace) %{HTTPDIR}/config.html
%dir %{HTTPDIR}/config/
%{HTTPDIR}/config/*
%{HTTPDIR}/default.css
%{HTTPDIR}/embeddedProjects.html
%{HTTPDIR}/exampleProject.txt
%config(noreplace) %{HTTPDIR}/favicon.ico
%config(noreplace) %{HTTPDIR}/footer
%config(noreplace) %{HTTPDIR}/head*
%config(noreplace) %{HTTPDIR}/help*.html
%config(noreplace) %{HTTPDIR}/index*.html
%config(noreplace) %{HTTPDIR}/messages*
%dir %{HTTPDIR}/rcdrecord/
%{HTTPDIR}/rcdrecord/*
%config(noreplace) %{HTTPDIR}/status*.html
%config(noreplace) %{HTTPDIR}/support*.html
%{HTTPDIR}/*.png
%dir %{HTTPDIR}/webCDcreator/
%config(noreplace) %{HTTPDIR}/webCDcreator/*.html
%config(noreplace) %{HTTPDIR}/webCDcreator/*.jnlp
%dir %{HTTPDIR}/webCDcreator/4netscape/
%{HTTPDIR}/webCDcreator/4netscape/*
%dir %{HTTPDIR}/webCDcreator/4plugin/
%{HTTPDIR}/webCDcreator/4plugin/*
%dir %{HTTPDIR}/webCDcreator/4pluginRSA/
%{HTTPDIR}/webCDcreator/4pluginRSA/*
%dir %{HTTPDIR}/webCDcreator/doc/
%{HTTPDIR}/webCDcreator/doc/*
%dir %{HTTPDIR}/webCDcreator/errors/
%config(noreplace) %{HTTPDIR}/webCDcreator/errors/*
%dir %{HTTPDIR}/webCDcreator/help/
%config(noreplace) %{HTTPDIR}/webCDcreator/help/*
%dir %{HTTPDIR}/webCDcreator/i18n/
%{HTTPDIR}/webCDcreator/i18n/*
%dir %{HTTPDIR}/webCDcreator/icons/
%{HTTPDIR}/webCDcreator/icons/*
%dir %attr(-, %{USER}, %{GROUP}) %{MNTDIR}/
%dir %attr(-, %{USER}, %{GROUP}) %{PROJECTSDIR}/
%dir %attr(-, %{USER}, %{GROUP}) %{LOGDIR}/
%dir %attr(-, %{USER}, %{GROUP}) %{SPOOLDIR}/

%pre
# Add the "webCDwriter" user and group
/usr/sbin/groupadd %{GROUP} 2> /dev/null || :
/usr/sbin/useradd -c "system user for webCDwriter" \
	-g %{GROUP} %{USER} -r 2> /dev/null \
	|| /usr/sbin/useradd -c "system user for webCDwriter" \
		-g %{GROUP} %{USER} 2> /dev/null || :

# Since rpm will not change the owner of an existing %config file
/bin/chown %{USER} %{CONFIGDIR}/accounts 2> /dev/null || :
/bin/chown %{USER} %{CONFIGDIR}/config 2> /dev/null || :
/bin/chown %{USER} %{CONFIGDIR}/key.txt 2> /dev/null || :
/bin/chown %{USER} %{CONFIGDIR}/password 2> /dev/null || :
/bin/chmod 600 %{CONFIGDIR}/password 2> /dev/null || :
/bin/chown %{USER} %{LOGDIR}/CDinfos 2> /dev/null || :
/bin/chown %{USER} %{LOGDIR}/connects 2> /dev/null || :
/bin/chown %{USER} %{LOGDIR}/log 2> /dev/null || :
/bin/chown %{USER} %{LOGDIR}/sessions 2> /dev/null || :

if [ -e %{SBINDIR}/CDWserver-GPL ]; then
	rm -f %{SBINDIR}/CDWserver-GPL
fi

%post
if [ -x /sbin/chkconfig ]; then
	/sbin/chkconfig --add CDWserver
fi

if [ -x /sbin/insserv ]; then
	/sbin/insserv %{INITDIR}/CDWserver
fi

if [ -e /home/CDWserver/bin/ ]; then
	echo "Moving tools to %{TOOLSDIR}/..."
	for tool in cdrdao cdrecord mkisofs
	do
		if [ -e /home/CDWserver/bin/$tool ] \
				&& [ ! -e %{TOOLSDIR}/$tool ]; then
			mv /home/CDWserver/bin/$tool %{TOOLSDIR}/
		fi
	done
	rm -rf /home/CDWserver/bin/
fi

# make "setuid root copies" of cdrdao, cdrecord, mkisofs and readcd
for tool in cdrdao cdrecord mkisofs readcd
do
	if [ ! -e %{TOOLSDIR}/$tool ]; then
		if [ -e /usr/bin/$tool ]; then
			cp -af /usr/bin/$tool %{TOOLSDIR}/ || :
		else
			cp -af /usr/local/bin/$tool %{TOOLSDIR}/ 2> /dev/null || :
		fi
	fi
	if [ -e %{TOOLSDIR}/$tool ]; then
		chown root.%{GROUP} %{TOOLSDIR}/$tool || :
		chmod 4750 %{TOOLSDIR}/$tool || :
	fi
done

if [ -e /home/CDWserver/ ]; then
	echo "Moving projects to %{PROJECTSDIR}/..."
	mv /home/CDWserver/* %{PROJECTSDIR}/ 2> /dev/null || :
	rmdir /home/CDWserver/
fi

PORT="`grep '^portNo=' %{CONFIGDIR}/config | sed s/portNo=//g`"

if [ "$PORT" = "80" ]; then
	PORT_EXT=""
else
	if [ "$PORT" = "" ]; then
		PORT_EXT=":12411"
	else
		PORT_EXT=":$PORT"
	fi
fi

echo
echo
echo "To do:"
echo
echo "1. Enter \"%{INITDIR}/CDWserver start\" to start your webCDwriter"
echo
echo "2. Open your web browser and try"
echo
echo "   \"http://127.0.0.1$PORT_EXT\" or \"http://`hostname`$PORT_EXT\""
echo
echo "to check the status of your webCDwriter"
echo
echo "3. Run \"/usr/sbin/CDWconfig.sh\" to set the rights of CDWserver"
echo

%preun
if [ $1 = 0 ]; then
	%{INITDIR}/CDWserver stop || :

	if [ -x /sbin/chkconfig ]; then
		/sbin/chkconfig --del CDWserver
	fi

	if [ ! -e %{SPOOLDIR}/bin/ ]; then
		rm -rf %{SPOOLDIR}/*
	fi
fi

%postun
if [ $1 = 0 ]; then
	if [ -x /sbin/insserv ]; then
		/sbin/insserv %{INITDIR}
	fi
fi

if [ $1 -ge 1 ]; then
	%{INITDIR}/CDWserver condrestart
fi

%changelog
* Mon Aug 29 2005 Jrg P. M. Haeger <mail@JoergHaeger.de>
- get the PORT of the server in "post" from the config
- change "Copyright" to "License"
- remove setScheduler from the "files"
- use DESTDIR with "make install"

* Sat Feb 07 2004 Jrg Haeger <mail@JoergHaeger.de>
- changed the default user and group to "cdwserve"
- moved some of the default directories to /var/CDWserver/
  /etc/CDWserver/export -> /var/CDWserver/export
  /etc/CDWserver/http -> /var/CDWserver/http
  /home/CDWserver/bin -> /var/CDWserver/bin
  /home/CDWserver/* -> /var/CDWserver/projects/

* Tue Nov 18 2003 Jrg Haeger <mail@JoergHaeger.de>
- added /usr/sbin/useradd to the "Requires"

* Tue Jul 22 2003 Jrg Haeger <mail@JoergHaeger.de>
- use CDWinstall.sh to prepare copies of cdrdao, cdrecord and mkisofs

* Mon Jun 23 2003 Jrg Haeger <Joerg.Haeger@Uni-Bielefeld.de>
- list all directories explicitly in the files list

* Fri Jun 20 2003 Jrg Haeger <Joerg.Haeger@Uni-Bielefeld.de>
- web documents moved to /etc/CDWserver/http/

* Tue Mar 04 2003 Jrg Haeger <Joerg.Haeger@Uni-Bielefeld.de>
- do not change the owner and mode of cdrecord and mkisofs any more

* Tue Feb 25 2003 Jrg Haeger <Joerg.Haeger@Uni-Bielefeld.de>
- repair the owner and mode of cdrecord and mkisofs on uninstall

* Thu Oct 24 2002 Jrg Haeger <Joerg.Haeger@Uni-Bielefeld.de>
- added dvd+rw-format and growisofs

* Mon Jun 10 2002 Jrg Haeger <Joerg.Haeger@Uni-Bielefeld.de>
- try to detect mdk and SuSE releases
- replaced /etc/init.d by initDir

* Wed May 29 2002 Jrg Haeger <Joerg.Haeger@Uni-Bielefeld.de>
- integration into webCDwriter-version.tar.bz2
- replaced /etc/rc.d/init.d/ by /etc/init.d/

* Wed Apr 24 2002 Jrg Haeger <Joerg.Haeger@Uni-Bielefeld.de>
- web documents moved to /etc/CDWserver/webCDcreator/

* Wed Nov 14 2001 Jrg Haeger <Joerg.Haeger@Uni-Bielefeld.de>
- prepare start.jnlp for Java Web Start

* Tue Apr 17 2001 Jrg Haeger <Joerg.Haeger@Uni-Bielefeld.de>
- BuildRoot added
- putting the hostname to the applet start pages removed
- special /etc/init.d/CDWserver
